﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.5
@EndOfDesignText@
'The actual logger is a small c# WPFApplication that registers itself for receiving lid events
'It appends the laptop lid event to a file ("LidLogger.txt" in File.DirApp) 
'If the file does not exist or if the file disappears, the c# logger app closes itself.

Sub Class_Globals
	Private fx As JFX
	Private Enabled As Boolean
	Private sh As Shell
	Private CheckStatusTimer As Timer
	Private callBack As Object
	Private lastSize As Int
	Public LastChange As String
End Sub

Public Sub Initialize(callBack_ As Object)
	callBack = callBack_
	CheckStatusTimer.Initialize("checkStatus", 1000)
End Sub

'To start logging laptop lid action
Public Sub StartLogging
	If Enabled Then Return
	Enabled = True
	CheckStatusTimer.Enabled = True
	LastChange = ""
	lastSize = 0
	File.WriteString(File.DirApp, "LidLogger.txt", "")
	sh.Initialize("", File.DirApp & "\LidStatus\WpfApplication1.exe", Null)						'disable for testing this class
	sh.Run(-1)
	CallSub2(callBack, "Lid_Change", "Logging Started")
	
'	simulate lid closing during testing	
'	Sleep(2000)
'	File.WriteString(File.DirApp, "LidLogger.txt", "CLOSED")
End Sub

'To stop logging laptop lid action - logging file is deleted
' - After 2 seconds, logger closes itself automatically
' - To restart use StartLogging method
Public Sub StopLogging
	If Enabled = False Then Return
	CheckStatusTimer.Enabled = False
	Enabled = False
	File.Delete(File.DirApp, "LidLogger.txt")
	CallSub2(callBack, "Lid_Change", "Logging Stopped")
End Sub

Private Sub CheckStatus_Tick
	CheckStatusTimer.Enabled = False
	Dim states As List = File.ReadList(File.DirApp, "LidLogger.txt")
	If states.Size > lastSize Then
		CallSub2(callBack, "Lid_Change", states.Get(states.Size - 1))
		lastSize = states.Size
		LastChange = states.Get(states.Size - 1)
	End If
	CheckStatusTimer.Enabled = True
End Sub

Public Sub PollTimer(Interval As Int)
	CheckStatusTimer.Interval = Interval
End Sub